USE COWS
GO

SET DEADLOCK_PRIORITY 10;

OPEN SYMMETRIC KEY FS@K3y 
DECRYPTION BY CERTIFICATE S3cFS@CustInf0;

ALTER TABLE dbo.CUST_SCRD_DATA
ADD CTRY_CD [varbinary](max) NULL
GO

ALTER TABLE arch.CUST_SCRD_DATA
ADD CTRY_CD [varbinary](max) NULL
GO

INSERT INTO dbo.LK_SCRD_OBJ_TYPE(SCRD_OBJ_TYPE_ID,SCRD_OBJ_TYPE,SCRD_OBJ_TYPE_DES,REC_STUS_ID, CREAT_BY_USER_ID,MODFD_BY_USER_ID,MODFD_DT,CREAT_DT)  VALUES(28,'MPLS_EVENT_ACCS_TAG','MPLS_EVENT_ACCS_TAG',1,'1','1',GETDATE(),GETDATE())
INSERT INTO dbo.LK_SCRD_OBJ_TYPE(SCRD_OBJ_TYPE_ID,SCRD_OBJ_TYPE,SCRD_OBJ_TYPE_DES,REC_STUS_ID, CREAT_BY_USER_ID,MODFD_BY_USER_ID,MODFD_DT,CREAT_DT)  VALUES(29,'NRM_CKT','NRM_CKT',1,'1','1',GETDATE(),GETDATE())

INSERT INTO dbo.[CUST_SCRD_DATA] ([SCRD_OBJ_ID], [SCRD_OBJ_TYPE_ID], [CTY_NME], [STT_PRVN_NME])
SELECT DISTINCT me.[MPLS_EVENT_ACCS_TAG_ID], 28, dbo.encryptstring([LOC_CTY_NME]), dbo.encryptstring([LOC_STT_NME])
FROM dbo.[MPLS_EVENT_ACCS_TAG] me WITH (NOLOCK) INNER JOIN
dbo.[EVENT] ev WITH (NOLOCK) ON ev.EVENT_ID=me.EVENT_ID
WHERE (ev.CSG_LVL_ID > 0)
AND NOT EXISTS (SELECT 'x' FROM dbo.[CUST_SCRD_DATA] csd WITH (NOLOCK) WHERE csd.[SCRD_OBJ_ID]=me.[MPLS_EVENT_ACCS_TAG_ID] and csd.[SCRD_OBJ_TYPE_ID]=28)

INSERT INTO dbo.[CUST_SCRD_DATA] ([SCRD_OBJ_ID], [SCRD_OBJ_TYPE_ID], [CTY_NME], [STT_PRVN_NME])
SELECT DISTINCT me.[MPLS_EVENT_ACCS_TAG_ID], 28, dbo.encryptstring([LOC_CTY_NME]), dbo.encryptstring([LOC_STT_NME])
FROM arch.[MPLS_EVENT_ACCS_TAG] me WITH (NOLOCK) INNER JOIN
arch.[EVENT] ev WITH (NOLOCK) ON ev.EVENT_ID=me.EVENT_ID
WHERE (ev.CSG_LVL_ID > 0)
AND NOT EXISTS (SELECT 'x' FROM dbo.[CUST_SCRD_DATA] csd WITH (NOLOCK) WHERE csd.[SCRD_OBJ_ID]=me.[MPLS_EVENT_ACCS_TAG_ID] and csd.[SCRD_OBJ_TYPE_ID]=28)

INSERT INTO arch.[CUST_SCRD_DATA] ([ID], [SCRD_OBJ_ID], [SCRD_OBJ_TYPE_ID], [CTY_NME], [STT_PRVN_NME])
SELECT [ID], [SCRD_OBJ_ID], [SCRD_OBJ_TYPE_ID], [CTY_NME], [STT_PRVN_NME]
FROM dbo.[CUST_SCRD_DATA] csd WITH (NOLOCK) WHERE [SCRD_OBJ_TYPE_ID]=28
AND NOT EXISTS (SELECT 'X' FROM arch.[CUST_SCRD_DATA] acsd WITH (NOLOCK) WHERE acsd.[ID]=csd.[ID])
AND EXISTS (SELECT 'X' FROM arch.MPLS_EVENT_ACCS_TAG ame WITH (NOLOCK) WHERE ame.[MPLS_EVENT_ACCS_TAG_ID]=csd.[SCRD_OBJ_ID])

DELETE csd
FROM dbo.[CUST_SCRD_DATA] csd
WHERE csd.[SCRD_OBJ_TYPE_ID]=28
AND EXISTS (SELECT 'X' FROM arch.[CUST_SCRD_DATA] acsd WITH (NOLOCK) WHERE acsd.[ID]=csd.[ID])
AND EXISTS (SELECT 'X' FROM arch.MPLS_EVENT_ACCS_TAG ame WITH (NOLOCK) WHERE ame.[MPLS_EVENT_ACCS_TAG_ID]=csd.[SCRD_OBJ_ID])

INSERT INTO dbo.[CUST_SCRD_DATA] ([SCRD_OBJ_ID], [SCRD_OBJ_TYPE_ID], [CTY_NME], [STT_PRVN_NME], [SITE_ADR], [STREET_ADR_1], [STREET_ADR_2], [ZIP_PSTL_CD],
[CTRY_RGN_NME], [CTRY_CD])
SELECT nrc.[NRM_CKT_ID], 29, dbo.encryptstring([TOC_CTY_NME]), dbo.encryptstring([TOC_DMSTC_STT_NME]), 
dbo.encryptstring([TOC_ADR]), dbo.encryptstring([TOC_ADR_1]), dbo.encryptstring([TOC_ADR_2]), dbo.encryptstring([TOC_ZIP_CD]),
dbo.encryptstring([TOC_CTRY_NME]), dbo.encryptstring([TOC_CTRY_CD])
FROM dbo.NRM_CKT nrc WITH (NOLOCK) 
WHERE [NRM_CKT_ID] IN
(SELECT DISTINCT nc.[NRM_CKT_ID]
FROM dbo.[NRM_CKT] nc WITH (NOLOCK) INNER JOIN
dbo.[FSA_ORDR] fo WITH (NOLOCK) ON fo.FTN=nc.FTN INNER JOIN
dbo.ORDR ordr WITH (NOLOCK) ON ordr.ORDR_ID=fo.ORDR_ID
WHERE (ordr.CSG_LVL_ID > 0)
AND NOT EXISTS (SELECT 'x' FROM dbo.[CUST_SCRD_DATA] csd WITH (NOLOCK) WHERE csd.[SCRD_OBJ_ID]=nc.[NRM_CKT_ID] and csd.[SCRD_OBJ_TYPE_ID]=29))

INSERT INTO dbo.[CUST_SCRD_DATA] ([SCRD_OBJ_ID], [SCRD_OBJ_TYPE_ID], [CTY_NME], [STT_PRVN_NME], [SITE_ADR], [STREET_ADR_1], [STREET_ADR_2], [ZIP_PSTL_CD],
[CTRY_RGN_NME], [CTRY_CD])
SELECT nrc.[NRM_CKT_ID], 29, dbo.encryptstring([TOC_CTY_NME]), dbo.encryptstring([TOC_DMSTC_STT_NME]), 
dbo.encryptstring([TOC_ADR]), dbo.encryptstring([TOC_ADR_1]), dbo.encryptstring([TOC_ADR_2]), dbo.encryptstring([TOC_ZIP_CD]),
dbo.encryptstring([TOC_CTRY_NME]), dbo.encryptstring([TOC_CTRY_CD])
FROM arch.NRM_CKT nrc WITH (NOLOCK) 
WHERE [NRM_CKT_ID] IN
( SELECT DISTINCT nc.[NRM_CKT_ID]
FROM arch.[NRM_CKT] nc WITH (NOLOCK) INNER JOIN
arch.[FSA_ORDR] fo WITH (NOLOCK) ON fo.FTN=nc.FTN INNER JOIN
arch.ORDR ordr WITH (NOLOCK) ON ordr.ORDR_ID=fo.ORDR_ID
WHERE (ordr.CSG_LVL_ID > 0)
AND NOT EXISTS (SELECT 'x' FROM dbo.[CUST_SCRD_DATA] csd WITH (NOLOCK) WHERE csd.[SCRD_OBJ_ID]=nc.[NRM_CKT_ID] and csd.[SCRD_OBJ_TYPE_ID]=29))

INSERT INTO arch.[CUST_SCRD_DATA] ([ID], [SCRD_OBJ_ID], [SCRD_OBJ_TYPE_ID], [CTY_NME], [STT_PRVN_NME], [SITE_ADR], [STREET_ADR_1], [STREET_ADR_2], [ZIP_PSTL_CD],
[CTRY_RGN_NME], [CTRY_CD])
SELECT [ID], [SCRD_OBJ_ID], [SCRD_OBJ_TYPE_ID], [CTY_NME], [STT_PRVN_NME], [SITE_ADR], [STREET_ADR_1], [STREET_ADR_2], [ZIP_PSTL_CD],
[CTRY_RGN_NME], [CTRY_CD]
FROM dbo.[CUST_SCRD_DATA] csd WITH (NOLOCK) WHERE [SCRD_OBJ_TYPE_ID]=29
AND NOT EXISTS (SELECT 'X' FROM arch.[CUST_SCRD_DATA] acsd WITH (NOLOCK) WHERE acsd.[ID]=csd.[ID])
AND EXISTS (SELECT 'X' FROM arch.NRM_CKT anc WITH (NOLOCK) WHERE anc.[NRM_CKT_ID]=csd.[SCRD_OBJ_ID])

DELETE csd
FROM dbo.[CUST_SCRD_DATA] csd
WHERE csd.[SCRD_OBJ_TYPE_ID]=29
AND EXISTS (SELECT 'X' FROM arch.[CUST_SCRD_DATA] acsd WITH (NOLOCK) WHERE acsd.[ID]=csd.[ID])
AND EXISTS (SELECT 'X' FROM arch.NRM_CKT anc WITH (NOLOCK) WHERE anc.[NRM_CKT_ID]=csd.[SCRD_OBJ_ID])

--Update CTY_NME, CTRY_CD in H5_FOLDR
UPDATE csd
SET CTY_NME = dbo.encryptstring(hf.CUST_CTY_NME),
CTRY_CD = dbo.encryptstring(hf.CTRY_CD)
FROM dbo.[H5_FOLDR] hf WITH (NOLOCK) INNER JOIN
dbo.[CUST_SCRD_DATA] csd ON csd.SCRD_OBJ_ID=hf.H5_FOLDR_ID AND csd.SCRD_OBJ_TYPE_ID=6

UPDATE hf
SET CUST_CTY_NME = NULL,
CTRY_CD = NULL
FROM dbo.[H5_FOLDR] hf INNER JOIN
dbo.[CUST_SCRD_DATA] csd WITH (NOLOCK) ON csd.SCRD_OBJ_ID=hf.H5_FOLDR_ID AND csd.SCRD_OBJ_TYPE_ID=6

UPDATE csd
SET CTY_NME = dbo.encryptstring(hf.CUST_CTY_NME),
CTRY_CD = dbo.encryptstring(hf.CTRY_CD)
FROM arch.[H5_FOLDR] hf WITH (NOLOCK) INNER JOIN
arch.[CUST_SCRD_DATA] csd ON csd.SCRD_OBJ_ID=hf.H5_FOLDR_ID AND csd.SCRD_OBJ_TYPE_ID=6

UPDATE hf
SET CUST_CTY_NME = NULL,
CTRY_CD = NULL
FROM arch.[H5_FOLDR] hf INNER JOIN
arch.[CUST_SCRD_DATA] csd WITH (NOLOCK) ON csd.SCRD_OBJ_ID=hf.H5_FOLDR_ID AND csd.SCRD_OBJ_TYPE_ID=6


--Update EMAIL_ADR, CTY_NME and CTRY_CD in NCCO_ORDR
UPDATE csd
SET CTY_NME = dbo.encryptstring(nod.SITE_CITY_NME),
CTRY_CD = dbo.encryptstring(nod.CTRY_CD),
CUST_EMAIL_ADR = dbo.encryptstring(nod.EMAIL_ADR)
FROM dbo.NCCO_ORDR nod WITH (NOLOCK) INNER JOIN
dbo.[CUST_SCRD_DATA] csd ON csd.SCRD_OBJ_ID=nod.ORDR_ID AND csd.SCRD_OBJ_TYPE_ID=10

UPDATE nod
SET SITE_CITY_NME = NULL,
CTRY_CD = NULL,
EMAIL_ADR = NULL
FROM dbo.NCCO_ORDR nod INNER JOIN
dbo.[CUST_SCRD_DATA] csd WITH (NOLOCK) ON csd.SCRD_OBJ_ID=nod.ORDR_ID AND csd.SCRD_OBJ_TYPE_ID=10


UPDATE csd
SET CTY_NME = dbo.encryptstring(nod.SITE_CITY_NME),
CTRY_CD = dbo.encryptstring(nod.CTRY_CD),
CUST_EMAIL_ADR = dbo.encryptstring(nod.EMAIL_ADR)
FROM arch.NCCO_ORDR nod WITH (NOLOCK) INNER JOIN
arch.[CUST_SCRD_DATA] csd ON csd.SCRD_OBJ_ID=nod.ORDR_ID AND csd.SCRD_OBJ_TYPE_ID=10

UPDATE nod
SET SITE_CITY_NME = NULL,
CTRY_CD = NULL,
EMAIL_ADR = NULL
FROM arch.NCCO_ORDR nod INNER JOIN
arch.[CUST_SCRD_DATA] csd WITH (NOLOCK) ON csd.SCRD_OBJ_ID=nod.ORDR_ID AND csd.SCRD_OBJ_TYPE_ID=10